﻿Imports System.Xml
Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlClient

Partial Class _Default
    Inherits System.Web.UI.Page

    Private _dataSource As IEnumerable
    Private _VarMap As String = "var map = null;"
    Private _GetMapOpen As String = "function GetMap(){"
    Private _CloseBracket As String = "}"
    Private _LoadMap As String = "map.LoadMap();"
    Private _PinId1 As String = "var pinid1=0;"
    Private _Locs1Array As String = "var locs1 = new Array;"
    Private _MapAddPushpin As String = "map.AddShape(pin);"
    Private _IncrementPinId As String = "pinid1++;"
    Private _Latitude As String = "47.6"
    Private _Longitude As String = "-122.33"
    Private _ZoomLevel As Integer = 20

    Public Property ZoomLevel() As Integer
        Get
            Return _ZoomLevel
        End Get
        Set(ByVal value As Integer)
            _ZoomLevel = value
        End Set
    End Property

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        AddMapDiv()
    End Sub
    Protected Sub LoadBaseMap(ByVal type As String)
        Dim cScriptManager As ClientScriptManager = Page.ClientScript

        cScriptManager.RegisterClientScriptInclude("VEControlInclude", ConfigurationManager.AppSettings("VirtualEarthJavaScriptLibrary").ToString())
        If type = "Data" Then
            cScriptManager.RegisterClientScriptBlock(GetType(String), "Onload", LoadPushPins())
        Else
            cScriptManager.RegisterClientScriptBlock(GetType(String), "Onload", BasicMap())
        End If



    End Sub
    Protected Sub AddMapDiv()
        Controls.Add(New LiteralControl("<div id='MyMap' style=""position:relative; width:1024px; height:768px;""</div>"))
    End Sub
    Private Function BasicMap() As String
        Dim str As New StringBuilder()
        str.Append("<script language=""JavaScript"" type=""text/javascript"">")
        str.Append(_GetMapOpen & _VarMap & NewMap("MyMap") & "map.LoadMap(new VELatLong(" & ConfigurationManager.AppSettings("UKMapLatitude").ToString() & "," & ConfigurationManager.AppSettings("UKMapLongitude").ToString() & "), " & ZoomLevel.ToString() & ",'h', false);" & _CloseBracket)
        str.Append("</script>")
        Return str.ToString()
    End Function
    Private Function NewMap(ByVal MapName As String) As String
        Return "map=new VEMap('" & MapName & "');"
    End Function
    Private Function NewLocation(ByVal longitude As String, ByVal latitude As String) As String
        Return "var loc=new VELatLong(" & longitude & "," & latitude & ");"
    End Function
    Private Function AddPushPin(ByVal Arr As String, ByVal Location As String) As String
        Return Arr & ".push(" & Location & ");"
    End Function
    Private Function LoadPushPins() As String

        Dim str As New StringBuilder()
        str.Append("<script language=""JavaScript"" type=""text/javascript"">")
        'str.Append(_GetMapOpen & _VarMap & NewMap("MyMap") & _LoadMap)
        str.Append(_GetMapOpen & _VarMap & NewMap("MyMap") & "map.LoadMap(new VELatLong(" & ConfigurationManager.AppSettings("UKMapLatitude").ToString() & "," & ConfigurationManager.AppSettings("UKMapLongitude").ToString() & "), " & ZoomLevel.ToString() & ",'h', false);")


        Dim i As Integer = 0

        Dim dbReader As SqlDataReader
        Dim conn As New SqlConnection(ConfigurationManager.ConnectionStrings("VBUGevents").ConnectionString.ToString())
        Dim cmd As New SqlCommand("vbug_getEvents", conn)
        cmd.CommandType = CommandType.StoredProcedure
        Using conn
            conn.Open()
            dbReader = cmd.ExecuteReader(CommandBehavior.CloseConnection)
            While dbReader.Read()
                str.Append("var pin" & i.ToString() & " = new VEShape(VEShapeType.Pushpin, new VELatLong(" & dbReader.GetValue(4).ToString() & "," & dbReader.GetValue(5).ToString() & "));")
                str.Append("pin" & i.ToString() & ".SetTitle(""" & dbReader.GetString(0).ToString() & """);")
                str.Append("pin" & i.ToString() & ".SetDescription(""" & dbReader.GetValue(1).ToString() & """);")
                str.Append("map.AddShape(pin" & i.ToString() & ");")
                i += 1
            End While
        End Using
        str.Append(_CloseBracket)
        str.Append("</script>")

        Return str.ToString()
    End Function

    Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
        If Request.QueryString.Count > 0 Then
            If Request.QueryString("Events").ToString() = "true" Then
                ZoomLevel = 6
                LoadBaseMap("Data")
            End If
        Else
            ZoomLevel = 6
            LoadBaseMap("Basic")
        End If
    End Sub
End Class
